﻿using BlackBerry.Workspaces.Enums;
using System;

namespace BlackBerry.Workspaces.Examples
{
    /// <summary>
    /// Examples of downloading a file

    public class DownloadFilesExample
    {
        private ApiSession apiSession;

        /// <summary>
        /// Creates an instances of the DownloadFilesExample class
        /// </summary>
        /// <param name="apiSession">
        /// An ApiSession instance to be used.
        /// </param>
        public DownloadFilesExample(ApiSession apiSession)
        {
            this.apiSession = apiSession;
        }
        /// <summary>
        /// DownloadFileById
        ///</summary>
        public void DownloadFileById(string docId, int roomId, string destinationPath)
        {
            DateTime lastUpdateTime = DateTime.Now;

            // START SNIPPET: devGuide18
            #region devGuide18

            // Get an instance of DownloadManager
            DownloadManager downloadManager = apiSession.GetDownloadManager();

            // A call to the DownloadFileById
            downloadManager.DownloadFileById(docId, string.Empty, roomId,
                destinationPath, lastUpdateTime, true, true);

            #endregion
            // END SNIPPET: devGuide18
        }

        /// <summary>
        /// DownloadFileByName
        ///</summary>
        public void DownloadFileByName(int roomId, string folderPath, string docName, string destinationPath)
        {
            DateTime lastUpdateTime = new DateTime(2011, 11, 11, 11, 11, 11);

            // START SNIPPET: devGuide19
            #region devGuide19

            // Get an instance of DownloadManager
            DownloadManager downloadManager = apiSession.GetDownloadManager();

            // A call to the DownloadFileByName
            downloadManager.DownloadFileByName(roomId, folderPath, docName,
                destinationPath, lastUpdateTime);

            #endregion
            // END SNIPPET: devGuide19
        }

        /// <summary>
        /// DownloadFileToBuffer
        ///</summary>
        public byte[] DownloadFileToBuffer(string docId)
        {
            // START SNIPPET: devGuide20
            #region devGuide20

            // Get an instance of DownloadManager
            DownloadManager downloadManager = apiSession.GetDownloadManager();

            // A call to the DownloadFileToBuffer
            byte[] buffer = downloadManager.DownloadFileToBuffer(docId, DownloadTypes.ORIGINAL);

            #endregion
            // END SNIPPET: devGuide20
            return buffer;
        }

        ///<summary>
        /// Download the protected version of the document with the given Id to the destination path.
        /// </summary>
        public void DownloadProtectedFileById(string docId, string destinationPath)
        {
            // Get an instance of DownloadManager
            DownloadManager downloadManager = apiSession.GetDownloadManager();

            // A call to the DownloadProtectedFileById
            downloadManager.DownloadProtectedFileById(docId, destinationPath);
        }
    }
}
